#include <iostream>
#include <stdlib.h>
#include <math.h>
// -------------------------------------------------------------------------

using namespace std;
// -------------------------------------------------------------------------

/// \brief Zwraca kolejna liczbe pierwsza wiesza od podanej
///
/// \param refval - dodatnia wartosc referencyjna
/// \returns Zwraca kolejna liczbe pierwsza wiesza od podanej, jezeli podana liczba jest nieprawidlowa zwraca 0
int findnextprime(int refval)
{
    if(refval < 0)                      // zawsze mozemy podac abs(refval)
        return 0;

    refval++;                           // zakladamy ze refval jest wartoscia referencyjna
    if((refval%2) == 0)                 // jezeli pazysta obliczenie wartosci
        refval++;

    for(int p=refval;p>2;p+=2)
    {
        // sprawdzamy czy p jest liczba pierwsza
        bool t = false;
        int sq = sqrt(p);
        for(int i=3;(i<=sq) && (!t);i+=2)
            t = ((p%i) == 0);

        // czy znaleziono podzielnik p
        if(!t)
            return p;                   // jezeli p nie ma podzilenika to zwracamy ja jako liczbe pierwsza
    }

    return 0;
}
// -------------------------------------------------------------------------

int main(void)
{
    int maxval;
    cout << "Podaj maksymalna wartosc jaka chcesz przechowywac: ";
    cin >> maxval;
    cout << "p: " << findnextprime(maxval) << endl;

    return 0;
}
// -------------------------------------------------------------------------
